;--------------------------------------------------------
; file name: DFSERIPT.ASM
; writer: Jason Tseng
;---------
#define DFSERIPT_ASM
#INCLUDE DFSERIPT.INC

PUBLIC TRANSMIT
PUBLIC RECEIVE
BAUDRATE EQU BAUDRATECONST 
TX EQU TXPIN
RX EQU RXPIN
SDATA .SECTION 'DATA'
	COUNT DB ? 								
	TXREG DB ? 							;transmit data register
	RCREG DB ? 							;receive data register
	DELAY DB ? 
SERIAL .SECTION 'CODE'	
	TRANSMIT PROC 							;TRANSMIT subroutine
		MOV TXREG,A 
		MOV A,BAUDRATE
		MOV DELAY,A 
		CLR TX 							;start bit "0"
		MOV A,9 						;set bit of send data
		MOV COUNT,A 
	TXDELAY: 	
		SDZ DELAY 
		JMP TXDELAY 
		MOV A,BAUDRATE 	
		MOV DELAY,A 
		SDZ COUNT 
		JMP SENDBIT 					;transmit not complete,send next bit
		JMP ENDTX 						;transimit complete, end
	SENDBIT:
		RRC TXREG 
		SNZ C 	
		JMP LOBIT 
		SET TX 
		JMP TXDELAY
	LOBIT: 	
		CLR TX
		JMP TXDELAY
	ENDTX: 					
		NOP 							;delay
		NOP 							
		SET TX 							;stop bit "1"
	T1: 								
		SDZ DELAY 				
		JMP T1 			
		MOV A,BAUDRATE 						
		MOV DELAY,A 						
	T2: 								
		SDZ DELAY 						
		JMP T2 							
		RET 							
		TRANSMIT ENDP 						
	RECEIVE PROC 							;RECEIVE subroutine
		SZ RX 							;detect start bit "0"
		JMP RECEIVE 						
		MOV A,9 						
		MOV COUNT,A 						;set bit of receive data
		MOV A,BAUDRATE+1 			
		MOV DELAY,A 					
	RXDELAY: 							
		SDZ DELAY 						
		JMP RXDELAY 						
		MOV A,BAUDRATE+1 					
		MOV DELAY,A 						
		SDZ COUNT 						
		JMP RXBIT 						;receive not complete, receive next bit
		MOV A,RCREG 						;receive complete end
		RET 							
	RXBIT: 								
		SET C 							
		SNZ RX 							
		CLR C 							
		RRC RCREG 						
		JMP RXDELAY 						
		RECEIVE ENDP 						
	END
;-----
; End of DFSERIPT.ASM
;--------------------------------------------------------

